import { ChangeDetectorRef, NgZone, OnDestroy, OnInit } from '@angular/core';
import { DomSanitizer, SafeHtml } from '@angular/platform-browser';
import { Notification } from '../../interfaces/notification.type';
import { NotificationsService } from '../../services/notifications.service';
import { NotificationAnimationType } from '../../enums/notification-animation-type.enum';
export declare class NotificationComponent implements OnInit, OnDestroy {
    private notificationService;
    private domSanitizer;
    private cdr;
    private zone;
    timeOut: number;
    showProgressBar: boolean;
    pauseOnHover: boolean;
    clickToClose: boolean;
    clickIconToClose: boolean;
    maxLength: number;
    theClass: string;
    rtl: boolean;
    animate: NotificationAnimationType;
    position: number;
    item: Notification;
    title: any;
    content: any;
    titleIsTemplate: boolean;
    contentIsTemplate: boolean;
    htmlIsTemplate: boolean;
    progressWidth: number;
    safeSvg: SafeHtml;
    safeInputHtml: SafeHtml;
    private stopTime;
    private timer;
    private framesPerSecond;
    private sleepTime;
    private startTime;
    private endTime;
    private icon;
    constructor(notificationService: NotificationsService, domSanitizer: DomSanitizer, cdr: ChangeDetectorRef, zone: NgZone);
    ngOnInit(): void;
    ngOnDestroy(): void;
    startTimeOut(): void;
    onEnter(): void;
    onLeave(): void;
    onClick(event: MouseEvent): void;
    onClickIcon(event: MouseEvent): void;
    attachOverrides(): void;
    private instance;
    private remove;
    private contentType;
}
